// vs_center.cc

#include "vs_center.h"

#include <sigc++/object_slot.h>

vs_center::vs_center(vscreen_widget *w)
{
  set_subwidget(w);
  set_bg(-1);

  do_layout.connect(slot(*this, &vs_center::layout_me));
}

size vs_center::size_request()
{
  if(get_subwidget() && get_subwidget()->get_visible())
    return get_subwidget()->size_request();
  else
    return size(0,0);
}

void vs_center::layout_me()
{
  if(get_subwidget())
    {
      if(get_subwidget()->get_visible())
	{
	  size subsize=get_subwidget()->size_request();
	  if(subsize.w>getmaxx())
	    subsize.w=getmaxx();
	  if(subsize.h>getmaxy())
	    subsize.h=getmaxy();
	  get_subwidget()->alloc_size((getmaxx()-subsize.w)/2, (getmaxy()-subsize.h)/2, subsize.w, subsize.h);
	}
      else
	get_subwidget()->alloc_size(0, 0, 0, 0);
    }
}
